/*
 * configmanager.hpp - Kukatz 3D
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *   2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *   3. This notice may not be removed or altered from any source
 *      distribution.
 */

#ifndef CONFIGMANAGER_HPP_INCLUDED
#define CONFIGMANAGER_HPP_INCLUDED

#include <map>
#include <string>
#include <sstream>

#include "singleton.hpp"

class ConfigManager: public Singleton < ConfigManager >
{
private:
	std::map<std::string, std::string> values;
	std::stringstream ss;
	
public:
	ConfigManager();
	
	void save();
	
	bool is_set(std::string);
	
	bool get_bool(std::string);
	int get_int(std::string);
	float get_float(std::string);
	std::string get_string(std::string);
	
	void set(std::string, bool);
	void set(std::string, int);
	void set(std::string, float);
	void set(std::string, std::string);
	
	virtual ~ConfigManager();
};

#endif // CONFIGMANAGER_HPP_INCLUDED
