/*
 * font.hpp - Kukatz 3D
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *	 1. The origin of this software must not be misrepresented; you must not
 *			claim that you wrote the original software. If you use this software
 *			in a product, an acknowledgment in the product documentation would be
 *			appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *			misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *			distribution.
 */

#ifndef FONT_HPP_INCLUDED
#define FONT_HPP_INCLUDED

#include <string>
#include <map>
#include <vector>

#include "opengl.hpp"
#include "texture.hpp"

class Font
{
public:
	Font(std::string, const unsigned char*, sf::Uint32);
	
	struct glyph_t
	{
		sf::Uint16 x;
		sf::Uint16 y;
		sf::Uint16 w;
		sf::Uint16 h;
		sf::Int16 xo;
		sf::Int16 yo;
		sf::Int16 xa;
		
		std::vector< std::pair< sf::Uint32, sf::Int16 > > kernings;
	};
	
	Texture* texture_ptr;
	
	sf::Uint16 size;
	sf::Uint16 line_height;
	sf::Uint16 base;
	
	std::map< sf::Uint32, glyph_t > glyphs;
	
	~Font();
};

#endif // FONT_HPP_INCLUDED
