/*
 * gameover.hpp - XD-Ball
 * Copyright (c) 2012 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *      distribution.
 */

#ifndef GAMEOVER_HPP_INCLUDED
#define GAMEOVER_HPP_INCLUDED

#include <vector>

#include <SFML/System/Vector2.hpp>
#include <SFML/Window/Event.hpp>
#include <SFML/Audio/Music.hpp>

#include "statebase.hpp"
#include "background.hpp"
#include "guielementcontainer.hpp"
#include "guistring.hpp"

class GameOver: public StateBase
{
private:
	Background background;
	GUIElementContainer gui;
	
	GUIString* title;
	GUIString* your_score;
	GUIString* enter_your_name;
	GUIString* your_name;
	
	GUIElementContainer* table;
	
	float time;
	bool entering_name;
	
	bool success;
	unsigned int score;
	sf::Unicode::Text name;
	
	char score_buffer[32];
	
public:
	GameOver(unsigned int, unsigned int, bool, unsigned int);
	
	sf::Music music;
	
	virtual void process_events(std::vector< sf::Event >&);
	virtual void render();
	virtual void update(float);
	virtual void resize(const sf::Vector2i&);
	
	virtual ~GameOver();
};

#endif // GAMEOVER_HPP_INCLUDED
