/*
 * guielement.hpp - Kukatz 3D
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *	 1. The origin of this software must not be misrepresented; you must not
 *			claim that you wrote the original software. If you use this software
 *			in a product, an acknowledgment in the product documentation would be
 *			appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *			misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *			distribution.
 */

#ifndef GUIELEMENT_HPP_INCLUDED
#define GUIELEMENT_HPP_INCLUDED

#include <SFML/System/Vector2.hpp>

#include "renderable.hpp"

class GUIElement: public Renderable
{
public:
	enum ScaleMode
	{
		SCALE_MODE_HORIZONTAL,
		SCALE_MODE_VERTICAL,
		SCALE_MODE_SMALLER,
		SCALE_MODE_BIGGER
	} scale_mode;
	
	GUIElement();
	
	bool visible;
	
	float scale;
	float aspect_ratio;
	sf::Vector2f align;
	
	sf::Vector2i size;
	
	virtual ~GUIElement();
};

#endif // GUIELEMENT_HPP_INCLUDED
