/*
 * particle.hpp - XD-Ball
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *      distribution.
 */

#ifndef PARTICLE_HPP_INCLUDED
#define PARTICLE_HPP_INCLUDED

#include "sprite.hpp"

#include <SFML/System/Vector2.hpp>

class Particle: public Sprite
{
protected:
	float time;
	float duration;
	
	sf::Vector2f speed;
	
public:
	Particle(const sf::Vector2f&, const sf::Vector2f&, float = 2.0f, const sf::Color& = sf::Color(255, 255, 255, 255));
	
	virtual void update(float);
	
	bool is_dead();
	
	virtual ~Particle();
};

#endif // PARTICLESYSTEM_HPP_INCLUDED
