/*
 * resources.hpp - XD-Ball
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *      distribution.
 */

#ifndef RESOURCES_HPP_INCLUDED
#define RESOURCES_HPP_INCLUDED

#include <map>
#include <string>
#include <vector>

#include <SFML/Audio/SoundBuffer.hpp>

#include "singleton.hpp"

#include "texture.hpp"
#include "font.hpp"

class Resources: public Singleton< Resources >
{
public:
	Resources();
	
	std::map< std::string, Texture* > textures;
	std::map< std::string, sf::SoundBuffer* > sounds;
	std::map< std::string, std::vector< sf::Uint8 >* > tracks;
	std::map< std::string, Font* > fonts;
	
	virtual ~Resources();
};

#endif // RESOURCES_HPP_INCLUDED
