/*
 * selector.hpp
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *   2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *   3. This notice may not be removed or altered from any source
 *      distribution.
 */

#ifndef SELECTOR_HPP_INCLUDED
#define SELECTOR_HPP_INCLUDED

#include <vector>

#include <SFML/System/Unicode.hpp>

#include "guielementcontainer.hpp"
#include "guistring.hpp"
#include "background.hpp"

class Selector: public GUIElementContainer
{
private:
	GUIString* label;
	
	GUIString* leftarrow_single;
	GUIString* leftarrow_double;
	GUIString* rightarrow_single;
	GUIString* rightarrow_double;
	
	GUIElementContainer* label_container;
	GUIElementContainer* leftarrow_container;
	GUIElementContainer* option_container;
	GUIElementContainer* rightarrow_container;
	
	std::vector< GUIString* > options;
	
	bool turnaround;
	unsigned int current_option;
	
	void update_arrows();
	
public:
	Selector(const sf::Unicode::Text&, const std::vector< sf::Unicode::Text >&,
		unsigned int = 0, bool = false, float = 10.0f, float = 0.5f);
	
	float separator;
	
	virtual void render();
	
	void set_color(sf::Uint8, sf::Uint8, sf::Uint8, sf::Uint8 = 255);
	
	unsigned int get_option();
	
	void next();
	void prev();
	
	virtual ~Selector();
};

#endif // DELECTOR_HPP_INCLUDED
